@ECHO OFF

REM 
REM Copyright 2009-2018, Tecknodreams Software Consulting Pvt. Ltd.
REM sapphireimsagent-install-upgrade script.
REM

CD "%~dp0"

REM ----------------------------------------------------------------------------------------------------
SET "PACKAGE_LOCATION=\\ShareComputer\ShareFolder\AgentPackageName.exe"
SET BASELINE_AGENT_VERSION=4.4001-3
REM ----------------------------------------------------------------------------------------------------

IF NOT EXIST "%PACKAGE_LOCATION%" (
	ECHO agent package is not available in specified path "%PACKAGE_LOCATION%". Hence exiting
	GOTO TERMINATE_PROGRAM
)

IF EXIST "%PROGRAMFILES(X86)%" (
     REM This is 64 Bit Operating system
     SET regQueryKey="HKEY_LOCAL_MACHINE\SOFTWARE\wow6432node\Tecknodreams\SapphireIMSAgent"
	 SET AppWizRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\SapphireIMSAgent"
	 SET StartupRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Run"
	 SET "InstalledPath=%PROGRAMFILES(X86)%\SapphireIMSAgent"
) ELSE (
    REM This is 32 Bit Operating system
    SET regQueryKey="HKEY_LOCAL_MACHINE\SOFTWARE\Tecknodreams\SapphireIMSAgent"
	SET AppWizRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\SapphireIMSAgent"
	SET StartupRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run"
	SET "InstalledPath=%PROGRAMFILES%\SapphireIMSAgent"
)

FOR /F "usebackq skip=2 tokens=1,2*" %%A IN (
 `REG QUERY %regQueryKey% /v "version" 2^>nul`) DO (
      set CURRENT_AGENT_VERSION=%%C
)
IF "%CURRENT_AGENT_VERSION%"=="" (
	ECHO Agent is not available. Hence installing.
	GOTO SAPP_INSTALL
)

IF "%CURRENT_AGENT_VERSION%" EQU "%BASELINE_AGENT_VERSION%" (
	ECHO Agent installed version is equal to %BASELINE_AGENT_VERSION%. Hence exiting.
	GOTO TERMINATE_PROGRAM
)
IF "%CURRENT_AGENT_VERSION%" GTR  "%BASELINE_AGENT_VERSION%"  (
	ECHO Agent installed version is higher than %BASELINE_AGENT_VERSION% - current version is %CURRENT_AGENT_VERSION%. Hence exiting.
	GOTO TERMINATE_PROGRAM
)

TIMEOUT /T 900

ECHO Agent version is older than %BASELINE_AGENT_VERSION%. Hence upgrading.

:SAPP_INSTALL
REM Launching installer.
"%PACKAGE_LOCATION%"

echo  "Completed"
ECHO "agent installed through active directory push." > "%InstalledPath%\agent-active-directory-push.txt"

:TERMINATE_PROGRAM
