@ECHO OFF

REM 
REM Copyright 2009-2018, Tecknodreams Software Consulting Pvt. Ltd.
REM sapphireimsagent-only-install-if-not-available script. share with credential installation.
REM

CD "%~dp0"

REM ----------------------------------------------------------------------------------------------------
SET "SHARED_FOLDER=\\172.16.9.93\agentinstaller"
SET "PACKAGE_NAME=AgentPackage.exe"
SET USERNAME=domain_name\user_123
SET PASSWORD=12345
SET BASELINE_AGENT_VERSION=4.4001-3
REM ----------------------------------------------------------------------------------------------------


IF EXIST "%PROGRAMFILES(X86)%" (
     REM This is 64 Bit Operating system
     SET regQueryKey="HKEY_LOCAL_MACHINE\SOFTWARE\wow6432node\Tecknodreams\SapphireIMSAgent"
	 SET AppWizRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\SapphireIMSAgent"
	 SET StartupRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Run"
	 SET "InstalledPath=%PROGRAMFILES(X86)%\SapphireIMSAgent"
) ELSE (
    REM This is 32 Bit Operating system
    SET regQueryKey="HKEY_LOCAL_MACHINE\SOFTWARE\Tecknodreams\SapphireIMSAgent"
	SET AppWizRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\SapphireIMSAgent"
	SET StartupRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run"
	SET "InstalledPath=%PROGRAMFILES%\SapphireIMSAgent"
)

FOR /F "usebackq skip=2 tokens=1,2*" %%A IN (
 `REG QUERY %regQueryKey% /v "version" 2^>nul`) DO (
      set CURRENT_AGENT_VERSION=%%C
)
IF "%CURRENT_AGENT_VERSION%"=="" (
	ECHO Agent is not available. Hence installing.
) ELSE (
	ECHO Agent is already available. Hence exiting.
	GOTO TERMINATE_BATCH
)

net use "%SHARED_FOLDER%" %PASSWORD% /user:%USERNAME%
SET "LAUNCH_FILE=%SHARED_FOLDER%\%PACKAGE_NAME%"
IF NOT EXIST "%LAUNCH_FILE%" (
	ECHO agent package is not available in specified path "%LAUNCH_FILE%". Hence exiting
	GOTO TERMINATE_PROGRAM_DELETE_SHARE
)
REM Launching installer.
"%LAUNCH_FILE%"


echo  "Completed"
ECHO "agent installed through active directory push." > "%InstalledPath%\agent-active-directory-push.txt"

:TERMINATE_PROGRAM_DELETE_SHARE
net use "%SHARED_FOLDER%" /delete

:TERMINATE_PROGRAM
