@ECHO OFF

REM 
REM Copyright 2009-2018, Tecknodreams Software Consulting Pvt. Ltd.
REM sapphireimsagent-uninstall-reinstall-wrong-serverconf2 script. share with credential installation.
REM

CD "%~dp0"

REM ----------------------------------------------------------------------------------------------------
SET "SHARED_FOLDER=\\172.16.9.93\agentinstaller"
SET "PACKAGE_NAME=AgentPackage.exe"
SET USERNAME=domain_name\user_123
SET PASSWORD=12345
SET ACTUAL_SERVER_NAME=customer.sapphireims.com
SET ACTUAL_SERVER_PORT=80
SET ACTUAL_HTTPS_FLAG=0
REM ----------------------------------------------------------------------------------------------------

net use "%SHARED_FOLDER%" %PASSWORD% /user:%USERNAME%
SET "LAUNCH_FILE=%SHARED_FOLDER%\%PACKAGE_NAME%"
IF NOT EXIST "%LAUNCH_FILE%"  (
	ECHO agent package is not available in specified path "%LAUNCH_FILE%". Hence exiting
	GOTO TERMINATE_PROGRAM_DELETE_SHARE
)

IF EXIST "%PROGRAMFILES(X86)%" (
     REM This is 64 Bit Operating system
     SET regQueryKey="HKEY_LOCAL_MACHINE\SOFTWARE\wow6432node\Tecknodreams\SapphireIMSAgent"
	 SET AppWizRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\SapphireIMSAgent"
	 SET StartupRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Run"
	 SET "InstalledPath=%PROGRAMFILES(X86)%\SapphireIMSAgent"
) ELSE (
    REM This is 32 Bit Operating system
    SET regQueryKey="HKEY_LOCAL_MACHINE\SOFTWARE\Tecknodreams\SapphireIMSAgent"
	SET AppWizRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\SapphireIMSAgent"
	SET StartupRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run"
	SET "InstalledPath=%PROGRAMFILES%\SapphireIMSAgent"
)
SET CURRENT_SERVER_PORT=
SET CURRENT_SERVER_NAME=
SET INIPATH="%InstalledPath%\ServerConf.ini"

IF NOT EXIST %INIPATH% (
	ECHO agent is not available. Hence installing
	GOTO SAPP_INSTALL
)

SET "SERV_CONF_EXE_PATH=%SHARED_FOLDER%\read-server-conf-value.exe"
IF NOT EXIST "%SERV_CONF_EXE_PATH%" (
	ECHO read-server-conf-value.exe is not available. Hence terminating
	GOTO TERMINATE_PROGRAM_DELETE_SHARE
)
COPY /Y "%SERV_CONF_EXE_PATH%" "%~dp0"

FOR /F "usebackq delims=" %%A IN (`read-server-conf-value.exe %INIPATH% AGENTCONF Port`) DO (
	SET CURRENT_SERVER_PORT=%%A
)
FOR /F "usebackq delims=" %%A IN (`read-server-conf-value.exe %INIPATH% AGENTCONF ServerIP`) DO (
	SET CURRENT_SERVER_NAME=%%A
)
FOR /F "usebackq delims=" %%A IN (`read-server-conf-value.exe %INIPATH% AGENTSSL HTTPSEnabled`) DO (
	SET CURRENT_HTTPS_FLAG=%%A
)

IF NOT "%CURRENT_SERVER_PORT%" EQU "%ACTUAL_SERVER_PORT%" (
	ECHO server port is not equal. Hence uninstalling and reinstalling. current port "%CURRENT_SERVER_PORT%"
	GOTO SAPP_CLEANUP
) 
IF NOT "%CURRENT_SERVER_NAME%" EQU "%ACTUAL_SERVER_NAME%" (
	ECHO server name is not equal. Hence uninstalling and reinstalling. current server name "%CURRENT_SERVER_NAME%"
	GOTO SAPP_CLEANUP
)
IF NOT "%CURRENT_HTTPS_FLAG%" EQU "%ACTUAL_HTTPS_FLAG%" (
	ECHO HTTPS flag is not equal. Hence uninstalling and reinstalling. current flag value "%CURRENT_HTTPS_FLAG%"
	GOTO SAPP_CLEANUP
)

ECHO server config parameters are proper. Hence exiting.
GOTO TERMINATE_PROGRAM_DELETE_SHARE

:SAPP_CLEANUP
TIMEOUT /T 900
SC STOP SAPPHIREIMSAGENT
SC STOP SAPPHIREIMSAGENTUPGRADE
FOR /F "tokens=*" %%A IN ('tasklist ^| FIND "SapphireIMSAgent.exe"') DO taskkill /F /IM SapphireIMSAgent.exe
FOR /F "tokens=*" %%A IN ('tasklist ^| FIND "SIMS_TaskAgent.exe"') DO taskkill /F /IM SIMS_TaskAgent.exe
FOR /F "tokens=*" %%A IN ('tasklist ^| FIND "AgentServiceTray.exe"') DO taskkill /F /IM AgentServiceTray.exe
FOR /F "tokens=*" %%A IN ('tasklist ^| FIND "SapphireIMSAgent-4.0-Setup.exe"') DO taskkill /F /IM SapphireIMSAgent-4.0-Setup.exe
FOR /F "tokens=*" %%A IN ('tasklist ^| FIND "SapphireIMSAgent-5.0-Setup.exe"') DO taskkill /F /IM SapphireIMSAgent-5.0-Setup.exe

SC DELETE SAPPHIREIMSAGENT
SC DELETE SAPPHIREIMSAGENTUPGRADE
REG DELETE %regQueryKey% /f
REG DELETE %AppWizRegistry% /f
REG DELETE %StartupRegistry% /v SapphireAgentTray /f
DEL "%ProgramData%\Microsoft\Windows\Start Menu\Programs\Startup\SapphireIMSAgent.lnk" /F /Q /S /A
DEL "%InstalledPath%\" /F /Q /S /A
RMDIR "%InstalledPath%\" /Q /S

TIMEOUT /T 3

:SAPP_INSTALL
REM Launching installer.
"%LAUNCH_FILE%"

echo  "Completed"
ECHO "agent installed through active directory push." > "%InstalledPath%\agent-active-directory-push.txt"

:TERMINATE_PROGRAM_DELETE_SHARE
net use "%SHARED_FOLDER%" /delete

:TERMINATE_PROGRAM
