@ECHO OFF

REM 
REM Copyright 2009-2018, Tecknodreams Software Consulting Pvt. Ltd.
REM sapphireimsagent-uninstall-old script.
REM

CD "%~dp0"

REM ----------------------------------------------------------------------------------------------------
SET BASELINE_AGENT_VERSION=4.4001-3
REM ----------------------------------------------------------------------------------------------------

IF EXIST "%PROGRAMFILES(X86)%" (
     REM 64 bit OS
     SET regQueryKey="HKEY_LOCAL_MACHINE\SOFTWARE\wow6432node\Tecknodreams\SapphireIMSAgent"
	 SET AppWizRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\SapphireIMSAgent"
	 SET StartupRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Run"
	 SET "InstalledPath=%PROGRAMFILES(X86)%\SapphireIMSAgent"
) ELSE (
    REM 32 bit OS
    SET regQueryKey="HKEY_LOCAL_MACHINE\SOFTWARE\Tecknodreams\SapphireIMSAgent"
	SET AppWizRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\SapphireIMSAgent"
	SET StartupRegistry="HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run"
	SET "InstalledPath=%PROGRAMFILES%\SapphireIMSAgent"
)

FOR /F "usebackq skip=2 tokens=1,2*" %%A IN (
 `REG QUERY %regQueryKey% /v "version" 2^>nul`) DO (
      set CURRENT_AGENT_VERSION=%%C
)

IF "%CURRENT_AGENT_VERSION%"=="" (
	ECHO Agent is not available.
	GOTO TERMINATE_PROGRAM
)

IF "%CURRENT_AGENT_VERSION%" EQU "%BASELINE_AGENT_VERSION%" (
	ECHO Agent installed version is equal to %BASELINE_AGENT_VERSION%
	GOTO TERMINATE_PROGRAM
)
IF "%CURRENT_AGENT_VERSION%" GTR  "%BASELINE_AGENT_VERSION%"  (
	ECHO Agent installed version is higher than %BASELINE_AGENT_VERSION% - current version is %CURRENT_AGENT_VERSION%.
	GOTO TERMINATE_PROGRAM
)

TIMEOUT /T 900
ECHO Agent version is older than %BASELINE_AGENT_VERSION%. Hence uninstalling.

SC STOP SAPPHIREIMSAGENT
SC STOP SAPPHIREIMSAGENTUPGRADE
FOR /F "tokens=*" %%A IN ('tasklist ^| FIND "SapphireIMSAgent.exe"') DO taskkill /F /IM SapphireIMSAgent.exe
FOR /F "tokens=*" %%A IN ('tasklist ^| FIND "SIMS_TaskAgent.exe"') DO taskkill /F /IM SIMS_TaskAgent.exe
FOR /F "tokens=*" %%A IN ('tasklist ^| FIND "AgentServiceTray.exe"') DO taskkill /F /IM AgentServiceTray.exe
FOR /F "tokens=*" %%A IN ('tasklist ^| FIND "SapphireIMSAgent-4.0-Setup.exe"') DO taskkill /F /IM SapphireIMSAgent-4.0-Setup.exe
FOR /F "tokens=*" %%A IN ('tasklist ^| FIND "SapphireIMSAgent-5.0-Setup.exe"') DO taskkill /F /IM SapphireIMSAgent-5.0-Setup.exe

SC DELETE SAPPHIREIMSAGENT
SC DELETE SAPPHIREIMSAGENTUPGRADE
REG DELETE %regQueryKey% /f
REG DELETE %AppWizRegistry% /f
REG DELETE %StartupRegistry% /v SapphireAgentTray /f
DEL "%ProgramData%\Microsoft\Windows\Start Menu\Programs\Startup\SapphireIMSAgent.lnk" /F /Q /S /A
DEL "%InstalledPath%\" /F /Q /S /A
RMDIR "%InstalledPath%\" /Q /S

TIMEOUT /T 3

ECHO  "Agent uninstallation completed"

:TERMINATE_PROGRAM